/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NullDependency = require('./NullDependency');

var ConstDependency = function (_NullDependency) {
  _inherits(ConstDependency, _NullDependency);

  function ConstDependency(expression, range) {
    _classCallCheck(this, ConstDependency);

    var _this = _possibleConstructorReturn(this, (ConstDependency.__proto__ || Object.getPrototypeOf(ConstDependency)).call(this));

    _this.expression = expression;
    _this.range = range;
    return _this;
  }

  _createClass(ConstDependency, [{
    key: 'updateHash',
    value: function updateHash(hash) {
      hash.update(this.range + '');
      hash.update(this.expression + '');
    }
  }]);

  return ConstDependency;
}(NullDependency);

ConstDependency.Template = function () {
  function ConstDependencyTemplate() {
    _classCallCheck(this, ConstDependencyTemplate);
  }

  _createClass(ConstDependencyTemplate, [{
    key: 'apply',
    value: function apply(dep, source) {
      if (typeof dep.range === 'number') {
        source.insert(dep.range, dep.expression);
        return;
      }

      source.replace(dep.range[0], dep.range[1] - 1, dep.expression);
    }
  }]);

  return ConstDependencyTemplate;
}();

module.exports = ConstDependency;